// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Cloud Guard and Security Zones API
//
// Use the Cloud Guard and Security Zones API to automate processes that you would otherwise perform through the Cloud Guard Console or the Security Zones Console. For more information on these services, see the Cloud Guard (https://docs.cloud.oracle.com/iaas/cloud-guard/home.htm) and Security Zones (https://docs.cloud.oracle.com/iaas/security-zone/home.htm) documentation.
// **Note:** For Cloud Guard, you can perform Create, Update, and Delete operations only from the reporting region of your Cloud Guard tenancy. You can perform Read operations from any region.
//

package cloudguard

import (
	"encoding/json"
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// LoggingQueryDataSourceSummaryDetails The information about new Logging Query of type DataSourceSummary.
type LoggingQueryDataSourceSummaryDetails struct {

	// DataSource customer specified regions
	Regions []string `mandatory:"false" json:"regions"`

	// DataSource mapping with detectorRecipe and detectorRule
	DataSourceDetectorMappingInfo []DataSourceMappingInfo `mandatory:"false" json:"dataSourceDetectorMappingInfo"`

	// DataSource query metadata replication region and status.
	RegionStatusDetail []RegionStatusDetail `mandatory:"false" json:"regionStatusDetail"`
}

func (m LoggingQueryDataSourceSummaryDetails) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m LoggingQueryDataSourceSummaryDetails) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}

// MarshalJSON marshals to json representation
func (m LoggingQueryDataSourceSummaryDetails) MarshalJSON() (buff []byte, e error) {
	type MarshalTypeLoggingQueryDataSourceSummaryDetails LoggingQueryDataSourceSummaryDetails
	s := struct {
		DiscriminatorParam string `json:"dataSourceFeedProvider"`
		MarshalTypeLoggingQueryDataSourceSummaryDetails
	}{
		"LOGGINGQUERY",
		(MarshalTypeLoggingQueryDataSourceSummaryDetails)(m),
	}

	return json.Marshal(&s)
}
