// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Container Engine for Kubernetes API
//
// API for the Container Engine for Kubernetes service. Use this API to build, deploy,
// and manage cloud-native applications. For more information, see
// Overview of Container Engine for Kubernetes (https://docs.cloud.oracle.com/iaas/Content/ContEng/Concepts/contengoverview.htm).
//

package containerengine

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// AddonVersionConfiguration Addon version configuration details.
type AddonVersionConfiguration struct {

	// If the the configuration is required or not.
	IsRequired *bool `mandatory:"false" json:"isRequired"`

	// Addon configuration key
	Key *string `mandatory:"false" json:"key"`

	// Addon configuration value
	Value *string `mandatory:"false" json:"value"`

	// Display name of addon version.
	DisplayName *string `mandatory:"false" json:"displayName"`

	// Information about the addon version configuration.
	Description *string `mandatory:"false" json:"description"`
}

func (m AddonVersionConfiguration) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m AddonVersionConfiguration) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
