// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Database Service API
//
// The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see Overview of the Database Service (https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/databaseoverview.htm).
//

package database

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// DrScanDetails The Single Client Access Name (SCAN) details for Disaster recovery network.
type DrScanDetails struct {

	// The Disaster recovery SCAN hostname.
	Hostname *string `mandatory:"true" json:"hostname"`

	// The Disaster recovery SCAN TCPIP port. Default is 1521.
	ScanListenerPortTcp *int `mandatory:"true" json:"scanListenerPortTcp"`

	// The list of Disaster recovery SCAN IP addresses. Three addresses should be provided.
	Ips []string `mandatory:"true" json:"ips"`
}

func (m DrScanDetails) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m DrScanDetails) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
