// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Java Management Service API
//
// API for the Java Management Service. Use this API to view, create, and manage Fleets.
//

package jms

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// KeySizeAlgorithm The algorithm object with name and key size properties.
type KeySizeAlgorithm struct {

	// The algorithm name.
	Name AlgorithmsEnum `mandatory:"false" json:"name,omitempty"`

	// Key size for the encryption algorithm.
	// Allowed values: 256 for EC, 2048 for DH/DSA/RSA
	KeySize *int `mandatory:"false" json:"keySize"`
}

func (m KeySizeAlgorithm) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m KeySizeAlgorithm) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if _, ok := GetMappingAlgorithmsEnum(string(m.Name)); !ok && m.Name != "" {
		errMessage = append(errMessage, fmt.Sprintf("unsupported enum value for Name: %s. Supported values are: %s.", m.Name, strings.Join(GetAlgorithmsEnumStringValues(), ",")))
	}
	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
