// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// MySQL Database Service API
//
// The API for the MySQL Database Service
//

package mysql

import (
	"encoding/json"
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// ErrorOnAnonymousHandling Disables assignment of IDs to anonymous transactions coming from the source. Use this policy when the transaction
// identifiers are enabled in the source of the replication channel.
type ErrorOnAnonymousHandling struct {
}

func (m ErrorOnAnonymousHandling) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m ErrorOnAnonymousHandling) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}

// MarshalJSON marshals to json representation
func (m ErrorOnAnonymousHandling) MarshalJSON() (buff []byte, e error) {
	type MarshalTypeErrorOnAnonymousHandling ErrorOnAnonymousHandling
	s := struct {
		DiscriminatorParam string `json:"policy"`
		MarshalTypeErrorOnAnonymousHandling
	}{
		"ERROR_ON_ANONYMOUS",
		(MarshalTypeErrorOnAnonymousHandling)(m),
	}

	return json.Marshal(&s)
}
