// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// OS Management Hub API
//
// Use the OS Management Hub API to manage and monitor updates and patches for the operating system environments in your private data centers through a single management console. For more information, see Overview of OS Management Hub (https://docs.cloud.oracle.com/iaas/osmh/doc/overview.htm).
// Use the table of contents and search tool to explore the  OS Management Hub API.
//

package osmanagementhub

import (
	"strings"
)

// SoftwareSourceTypeEnum Enum with underlying type: string
type SoftwareSourceTypeEnum string

// Set of constants representing the allowable values for SoftwareSourceTypeEnum
const (
	SoftwareSourceTypeVendor    SoftwareSourceTypeEnum = "VENDOR"
	SoftwareSourceTypeCustom    SoftwareSourceTypeEnum = "CUSTOM"
	SoftwareSourceTypeVersioned SoftwareSourceTypeEnum = "VERSIONED"
)

var mappingSoftwareSourceTypeEnum = map[string]SoftwareSourceTypeEnum{
	"VENDOR":    SoftwareSourceTypeVendor,
	"CUSTOM":    SoftwareSourceTypeCustom,
	"VERSIONED": SoftwareSourceTypeVersioned,
}

var mappingSoftwareSourceTypeEnumLowerCase = map[string]SoftwareSourceTypeEnum{
	"vendor":    SoftwareSourceTypeVendor,
	"custom":    SoftwareSourceTypeCustom,
	"versioned": SoftwareSourceTypeVersioned,
}

// GetSoftwareSourceTypeEnumValues Enumerates the set of values for SoftwareSourceTypeEnum
func GetSoftwareSourceTypeEnumValues() []SoftwareSourceTypeEnum {
	values := make([]SoftwareSourceTypeEnum, 0)
	for _, v := range mappingSoftwareSourceTypeEnum {
		values = append(values, v)
	}
	return values
}

// GetSoftwareSourceTypeEnumStringValues Enumerates the set of values in String for SoftwareSourceTypeEnum
func GetSoftwareSourceTypeEnumStringValues() []string {
	return []string{
		"VENDOR",
		"CUSTOM",
		"VERSIONED",
	}
}

// GetMappingSoftwareSourceTypeEnum performs case Insensitive comparison on enum value and return the desired enum
func GetMappingSoftwareSourceTypeEnum(val string) (SoftwareSourceTypeEnum, bool) {
	enum, ok := mappingSoftwareSourceTypeEnumLowerCase[strings.ToLower(val)]
	return enum, ok
}
