// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// RoverCloudService API
//
// A description of the RoverCloudService API.
//

package rover

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// RequestRoverBundleDetails Information required by Object Storage to process a request to copy an object to another bucket.
type RequestRoverBundleDetails struct {

	// The compartment OCID of destination compartment that the bundle will be copied to.
	DestinationCompartmentId *string `mandatory:"true" json:"destinationCompartmentId"`

	// The destination bucket name the bundle will be copied to.
	DestinationBucketName *string `mandatory:"true" json:"destinationBucketName"`

	// The bundle version that customer wants to upgrade to.
	BundleVersion *string `mandatory:"true" json:"bundleVersion"`
}

func (m RequestRoverBundleDetails) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m RequestRoverBundleDetails) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
