// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Web Application Acceleration (WAA) API
//
// API for the Web Application Acceleration service.
// Use this API to manage regional Web App Acceleration policies such as Caching and Compression
// for accelerating HTTP services.
//

package waa

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// GzipCompressionPolicy An object that specifies the gzip compression policy.
type GzipCompressionPolicy struct {

	// When true, support for gzip compression is enabled. HTTP responses will be compressed with gzip only if the
	// client indicates support for gzip via the "Accept-Encoding: gzip" request header.
	// When false, support for gzip compression is disabled and HTTP responses will not be compressed with gzip
	// even if the client indicates support for gzip.
	IsEnabled *bool `mandatory:"false" json:"isEnabled"`
}

func (m GzipCompressionPolicy) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m GzipCompressionPolicy) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
