// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Application Dependency Management API
//
// Use the Application Dependency Management API to create knowledge bases and vulnerability audits.  For more information, see ADM (https://docs.cloud.oracle.com/Content/application-dependency-management/home.htm).
//

package adm

import (
	"encoding/json"
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// ExternalResourceVulnerabilityAuditSource External source for the Vulnerability Audit.
type ExternalResourceVulnerabilityAuditSource struct {

	// Description of the external resource source.
	Description *string `mandatory:"false" json:"description"`
}

func (m ExternalResourceVulnerabilityAuditSource) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m ExternalResourceVulnerabilityAuditSource) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}

// MarshalJSON marshals to json representation
func (m ExternalResourceVulnerabilityAuditSource) MarshalJSON() (buff []byte, e error) {
	type MarshalTypeExternalResourceVulnerabilityAuditSource ExternalResourceVulnerabilityAuditSource
	s := struct {
		DiscriminatorParam string `json:"type"`
		MarshalTypeExternalResourceVulnerabilityAuditSource
	}{
		"EXTERNAL_RESOURCE",
		(MarshalTypeExternalResourceVulnerabilityAuditSource)(m),
	}

	return json.Marshal(&s)
}
