// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) API to manage scan recipes, targets, and reports. For more information, see the Vulnerability Scanning documentation (https://docs.cloud.oracle.com/iaas/scanning/home.htm).
//

package vulnerabilityscanning

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// FolderToScan Folder selected for scanning
type FolderToScan struct {

	// Operating system type
	Operatingsystem OperatingSystemEnum `mandatory:"true" json:"operatingsystem"`

	// Folder to be scanned in the corresponding operating system
	Folder *string `mandatory:"true" json:"folder"`
}

func (m FolderToScan) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m FolderToScan) ValidateEnumValue() (bool, error) {
	errMessage := []string{}
	if _, ok := GetMappingOperatingSystemEnum(string(m.Operatingsystem)); !ok && m.Operatingsystem != "" {
		errMessage = append(errMessage, fmt.Sprintf("unsupported enum value for Operatingsystem: %s. Supported values are: %s.", m.Operatingsystem, strings.Join(GetOperatingSystemEnumStringValues(), ",")))
	}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
