// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) API to manage scan recipes, targets, and reports. For more information, see the Vulnerability Scanning documentation (https://docs.cloud.oracle.com/iaas/scanning/home.htm).
//

package vulnerabilityscanning

import (
	"strings"
)

// OperatingSystemEnum Enum with underlying type: string
type OperatingSystemEnum string

// Set of constants representing the allowable values for OperatingSystemEnum
const (
	OperatingSystemLinux   OperatingSystemEnum = "LINUX"
	OperatingSystemWindows OperatingSystemEnum = "WINDOWS"
)

var mappingOperatingSystemEnum = map[string]OperatingSystemEnum{
	"LINUX":   OperatingSystemLinux,
	"WINDOWS": OperatingSystemWindows,
}

var mappingOperatingSystemEnumLowerCase = map[string]OperatingSystemEnum{
	"linux":   OperatingSystemLinux,
	"windows": OperatingSystemWindows,
}

// GetOperatingSystemEnumValues Enumerates the set of values for OperatingSystemEnum
func GetOperatingSystemEnumValues() []OperatingSystemEnum {
	values := make([]OperatingSystemEnum, 0)
	for _, v := range mappingOperatingSystemEnum {
		values = append(values, v)
	}
	return values
}

// GetOperatingSystemEnumStringValues Enumerates the set of values in String for OperatingSystemEnum
func GetOperatingSystemEnumStringValues() []string {
	return []string{
		"LINUX",
		"WINDOWS",
	}
}

// GetMappingOperatingSystemEnum performs case Insensitive comparison on enum value and return the desired enum
func GetMappingOperatingSystemEnum(val string) (OperatingSystemEnum, bool) {
	enum, ok := mappingOperatingSystemEnumLowerCase[strings.ToLower(val)]
	return enum, ok
}
