// Copyright (c) 2016, 2018, 2023, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) API to manage scan recipes, targets, and reports. For more information, see the Vulnerability Scanning documentation (https://docs.cloud.oracle.com/iaas/scanning/home.htm).
//

package vulnerabilityscanning

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// UpdateHostScanTargetDetails The information to update an existing host scan target
type UpdateHostScanTargetDetails struct {

	// Target identifier, which can be renamed. Avoid entering confidential information.
	DisplayName *string `mandatory:"false" json:"displayName"`

	// Target description.
	Description *string `mandatory:"false" json:"description"`

	// Compartment ID to target. If a list of hosts is provided, all hosts must be in this compartment.
	TargetCompartmentId *string `mandatory:"false" json:"targetCompartmentId"`

	// List of compute instance IDs to target (optional). If empty, targets the entire targetCompartmentId.
	InstanceIds []string `mandatory:"false" json:"instanceIds"`

	// ID of the host scan recipe this target applies.
	HostScanRecipeId *string `mandatory:"false" json:"hostScanRecipeId"`

	// Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
	// Example: `{"bar-key": "value"}`
	FreeformTags map[string]string `mandatory:"false" json:"freeformTags"`

	// Defined tags for this resource. Each key is predefined and scoped to a namespace.
	// Example: `{"foo-namespace": {"bar-key": "value"}}`
	DefinedTags map[string]map[string]interface{} `mandatory:"false" json:"definedTags"`
}

func (m UpdateHostScanTargetDetails) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m UpdateHostScanTargetDetails) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
